#ifndef TEPDIPRINCOMIXMODELSF_HPP
#define TEPDIPRINCOMIXMODELSF_HPP

#include <TeSharedPtr.h>
#include "TePDIMixModelStratFactory.hpp"
#include "TePDIParameters.hpp"
#include "TePDIStrategy.hpp"

/**
* @brief This is the class for garguet fusion strategy factory.
* @author Felipe Castro da Silva <felipe@dpi.inpe.br>
* @ingroup PDIStrategiesFactories
*/

class TePDIPrincoMixModelSF : public TePDIMixModelStratFactory
{
	public:
/**Default constructor.*/
		TePDIPrincoMixModelSF();
/**Default cestructor.*/
		~TePDIPrincoMixModelSF();

	protected:
/**
* Implementation for the abstract TeFactory::build.
* @param arg A const reference to the parameters used by the
* algorithm.
* @return A pointer to the new generated strategy instance.
*/
		TePDIMixModelStrategy* build( const TePDIParameters& arg );
};

namespace{static TePDIPrincoMixModelSF TePDIPrincoMixModelSF_instance;};

#endif
