#include "TePDIWavelets.hpp"
#include "TePDIStrategyFactory.hpp"
#include <TeAgnostic.h>


TePDIWavelets::TePDIWavelets()
{
}


TePDIWavelets::~TePDIWavelets()
{
}


void TePDIWavelets::ResetState( const TePDIParameters& params )
{
  TePDIParameters dummy_params = params;
}


bool TePDIWavelets::CheckParameters( const TePDIParameters& parameters ) const
{
  std::string wavelets_type;
  TEAGN_TRUE_OR_RETURN( parameters.GetParameter( "wavelets_type", 
    wavelets_type ), "Missing parameter : wavelets_type" );

  TePDIStrategy::pointer wavelets_strategy(  
    TePDIStrategyFactory::make( wavelets_type, parameters ) );
    
  TEAGN_TRUE_OR_RETURN( wavelets_strategy.isActive(), "Invalid strategy" );
  
  return wavelets_strategy->CheckParameters( parameters );
}


bool TePDIWavelets::RunImplementation()
{
  std::string wavelets_type;
  TEAGN_TRUE_OR_RETURN( params_.GetParameter( "wavelets_type", wavelets_type ),
    "Missing parameter : wavelets_type" );
    
  TePDIStrategy::pointer wavelets_strategy(  
    TePDIStrategyFactory::make( wavelets_type, params_ ) );
    
  TEAGN_TRUE_OR_RETURN( wavelets_strategy.isActive(), "Invalid strategy" );
  
  return wavelets_strategy->Apply( params_ );
}

